$(document).on('ready', function() {

  $(this).data('isAnimating', false);

  $("square.green").on('click',function() { 

    // If we are not currently animating
    if (!$(this).data('isAnimating')) {
      // Set a flag that we are
      $(this).data('isAnimating',true);
      var animationObject = this;

      // Calculate what we need to increment by in order to make our animation in the given amount of speed
      var currentWidth = $(this).width();
      var targetWidth = 500;
      var amountToMove = targetWidth - currentWidth;

      // Calculate the number of frames we need to draw
      var animationSpeed = 1000;
      var animationFrameRate = 10;
      var numberOfFrames = animationSpeed / animationFrameRate;

      // Calculate how much to increment the box per animation frame
      var widthStepSize = amountToMove / numberOfFrames;

      var animationFunction = function() {
        var frameNumber = $(animationObject).data('frameNumber') || 0;

        if (frameNumber != numberOfFrames) {
          var currentWidth = $(animationObject).width();
          var newWidth = currentWidth + widthStepSize;
          $(animationObject).width(newWidth);
          $(animationObject).data('frameNumber',frameNumber + 1);
        } else {
          var animationTimer = $(animationObject).data('timer');
          clearInterval(animationTimer);
        };
      };

      setInterval(animationFunction, animationFrameRate);
    };
  });
});

